JPG(1)

NAME
jpg, gif, png, ppm, bmp, yuv, ico, togif, toppm, topng, toico - view and convert pictures

SYNOPSIS
jpg [ -39cdefFkJrtv ] [ file ... ]
gif [ -39cdektv ] [ file ... ]
png [ -39cdektv ] [ file ... ]
ppm [ -39cdektv ] [ file ... ]
bmp [ file ]
yuv [ file ]

togif [ -c comment ] [ -l loopcount ] [ -d msec ] [ -t transindex ] [ file ... [ -d msec ] file ... ]
toppm [ -c comment ] [ file ]
topng [ -c comment ] [ [ -g gamma ] [ file ]

ico [ file ]
toico [ file ... ]

DESCRIPTION
These programs read, display, and write image files in public formats. Jpg, gif, png, ppm, bmp, and yuv. read files in the corresponding formats and, by default, display them in the current window; options cause them instead to convert the images to Plan 9 image format and write them to standard output. Togif, Toppm, and topng read Plan 9 images files, convert them to GIF, PPM, or PNG, and write them to standard output.

The default behavior of jpg, gif, and ppm is to display the file, or standard input if no file is named. Once a file is displayed, typing a character causes the program to display the next image. Typing a q, DEL, or control-D exits the program. For a more user-friendly interface, use page(1), which invokes these programs to convert the images to standard format, displays them, and offers scrolling, panning, and menu-driven navigation among the files.

These programs share many options:

-e  Disable Floyd-Steinberg error diffusion, which is used to improve the appearance of images on color-mapped displays, typically with 8 bits per pixel. Primarily useful for debugging; if the display has true RGB color, the image will be displayed in full glory.

-k  Convert and display the image as a black and white (really grey-scale) image.

-v  Convert the image to an RGBV color-mapped image, even if the display has true RGB color.

-d  Suppress display of the image; this is set automatically by any of the following options:

-c  Convert the image to a Plan 9 representation, as defined by image(7), and write it to standard output.

-9  Like -c, but produce an uncompressed image. This saves processing time, particularly when the output is being piped to another program such as page(1), since it avoids compression and decompression.

-t  Convert the image, if it is in color, to a true color RGB image.

-3  Like -t, but force the image to RGB even if it is originally grey-scale.

Jpg has two extra options used to process the output of the LML video card:

-f  Merge two adjacent images, which represent the two fields of a video picture, into a single image.

-F  The input is a motion JPEG file, with multiple images representing frames of the movie. Sets -f.

The togif and toppm programs go the other way: they convert from Plan 9 images to GIF and PPM, and have no display capability. Both accept an option -c to set the comment field of the resulting file. If there is only one input picture, togif converts the image to GIF format. If there are many files, though, it will assemble them into an animated GIF file. The options control this process:

-lloopcount
    By default, the animation will loop forever; loopcount specifies how many times to loop. A value of zero means loop forever and a negative value means to stop after playing the sequence once.

-dmsec
    By default, the images are displayed as fast as they can be rendered. This option specifies the time, in milliseconds, to pause while displaying the next named file.

Gif translates files that contain a `transparency' index by attaching an alpha channel to the converted image.

Ico displays a Windows icon (.ico) file. If no file is specified, ico reads from standard input. Icon files contain sets of icons represeted by an image and a mask. Clicking the right button pops up a menu that lets you write any icon's image as a Plan 9 image (widthxheight.image), write any icon's mask as a Plan 9 image (widthxheight.mask), or exit. Selecting one of the write menu items yields a sight cursor. Move the sight over the icon and right click again to write.

Toico takes a list of Plan 9 image files (or standard input) and creates a single icon file. The masks in the icon file will be the white space in the image. The icon file is written to standard output.

SOURCE
/src/cmd/jpg

SEE ALSO
page(1), image(7).

BUGS
Writing an animated GIF using togif is a clumsy undertaking.